<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { CtfButton } from '~/models';
export default Vue.extend({
  name: 'WhyUpgradeTable',
  props: {
    header: {
      type: String,
      required: false,
      default: '',
    },
    subheader: {
      type: String,
      required: false,
      default: '',
    },
    text: {
      type: String,
      required: false,
      default: '',
    },
    cta: {
      type: Object as PropType<CtfButton>,
      required: false,
      default: () => {},
    },
  },
  data() {
    return {};
  },
  methods: {
    formatTable(tableHtml: string) {
      return tableHtml.replaceAll(
        'true',
        '<span class="why-upgrade-check"><span/>',
      );
    },
  },
});
</script>
<template>
  <section id="free-vs-premium" class="why-upgrade-table slp-pt-48 slp-mt-48">
    <div class="gradient-line slp-mb-16"></div>
    <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-32">{{
      header
    }}</SlpTypography>
    <SlpTypography tag="h3" variant="heading4" class="slp-mb-32">{{
      subheader
    }}</SlpTypography>

    <div
      class="why-upgrade-table__table"
      v-html="$md.render(formatTable(text))"
    ></div>
    <SlpButton
      variant="tertiary"
      class="cta-button slp-mt-32"
      :href="cta.externalUrl"
      :data-ga-name="cta.dataGaName"
      :data-ga-location="cta.dataGaLocation"
    >
      {{ cta.text }}
      <SlpIcon
        class="slp-ml-8"
        name="chevron-lg-right"
        variant="product"
        alt="Chevron Right Icon"
      />
    </SlpButton>
  </section>
</template>

<style scoped lang="scss">
.why-upgrade-table {
  padding-top: 0;
  padding-bottom: 160px;
  &__table {
    &:deep(table) {
      border-spacing: 0;
      border-collapse: separate;
      width: 100%;

      thead {
        font-size: 24px;
        font-weight: 580;
        line-height: 28px;
        letter-spacing: -0.02em;
        text-align: center;

        th {
          border: 1px solid $color-primary-100;
          padding: 16px;
          border-top-left-radius: 4px;
          border-bottom: 0;
          border-right: 0;
          border-bottom: 1px solid $color-primary-100;
          text-align: center;

          &:first-of-type {
            border: none;
          }
          &:last-of-type {
            border-top-left-radius: 0;
            border-top-right-radius: 4px;
            border-right: 1px solid $color-primary-100;
          }

          strong {
            display: block;
            transform: rotate(180deg);
            writing-mode: tb;
            margin: 0 auto;
            @media (min-width: $breakpoint-md) {
              transform: none;
              writing-mode: inherit;
            }
          }
        }
      }
      tr {
        td {
          padding: 16px;
          text-align: center;
          border-left: 1px solid $color-primary-100;
          border-bottom: 1px solid $color-primary-100;
          width: 25%;
          strong {
            font-size: 14px;
          }
          &:first-of-type {
            border-left: none;
            text-align: left;
            padding-left: 0;
            width: 50%;
          }
          &:last-of-type {
            border-right: 1px solid $color-primary-100;
          }
        }
        &:first-of-type {
          td:first-of-type {
            border: none;
            border-bottom: 1px solid $color-primary-100;
          }
        }
        &:last-of-type {
          td:last-of-type {
            border-bottom-right-radius: 4px;
            border-right: 1px solid $color-primary-100;
          }
        }
      }
      .why-upgrade-check {
        position: relative;
        height: 16px;
        width: 16px;
        display: flex;
        justify-content: center;
        align-items: center;
        margin: 0 auto;
        &:before {
          content: '';
          height: 4px;
          width: 7px;
          border-right: 2px solid #48a651;
          border-top: 2px solid #48a651;
          position: relative;
          transform: rotate(130deg);
        }
        &:after {
          content: '';
          height: 16px;
          width: 16px;
          border-radius: 100%;
          border: 2px solid #48a651;
          position: absolute;
          left: 0;
          top: 0;
        }
      }
    }
  }
  .gradient-line {
    height: 4px;
    width: 96px;
    border-radius: 20px;
    background: rgb(255, 203, 215);
    background: linear-gradient(
      90deg,
      rgba(255, 203, 215, 1) 0%,
      rgba(241, 205, 234, 1) 51%,
      rgba(211, 191, 238, 1) 100%
    );
  }
}
</style>
